
{% for mapping in service["mappings"] | sort (attribute='has as source',reverse=True) %}
  # {{ mapping["has as source"] }}---
  {% set src  = mapping["has as source"] %}
  {% set dest = mapping["has as destination"] %}
  {% set dest_path = dest | regex_replace('https?:\/\/[^\/]+(.*)', '\\1') %}
  {% set dest_host = dest | regex_replace('https?:\/\/([^\/]+).*', '\\1') %}
  {% set src_path = src   | regex_replace('https?:\/\/[^\/]+(.*)', '\\1') %}
  {% set src_suffix="" %}
  {% set slash_redirect = "" %}

  {% if dest_path == "" %}
    {% set dest_path = "/" %}
    {% set src_suffix="/*" %}
    {% set slash_redirect="rewrite ^"+ src_path +"$ "+ src_path +"/ redirect;" %}
  {% endif %}

  {% if src_path == "" %}
    {% set src_path = "/" %}

    {% if dest_path != "/" %}
      {% set dest_path = dest_path+"/" %}
    {% endif %}
  {% endif %}

  location ~ ^{{ src_path }}{{ src_suffix }}(.*) {{ '{' }}
    {% if "has as CPL action" in mapping and mapping["has as CPL action"] is not none %}
      {% for cplAction in mapping["has as CPL action"] %}
        {% if "has as CPL action name" in cplAction %}
          {% if cplAction["has as CPL action name"] == "client_max_body_size" and cplAction["is enabled"] == "true" %}
            # body size limitation
            client_max_body_size {{ cplAction["has as CPL action"] }}M;
          {% endif %}
        {% endif %}
      {% endfor %}
    {% endif %}
    {% if mapping["has as destination"] is not none and mapping["has as destination"]|length > 0 %}
      #set     $proxy_url {{ mapping['has as destination'] }}/$1;
      {% set hash_host_port = mapping["has as source"] | join(mapping['has as destination']) | hash('md5') %}
      {% set dst_scheme     = mapping['has as destination'] | regex_replace('(https?).*', '\\1') %}
      # set     $proxy_dest {{  dest | regex_replace('https?:\/\/(.[^:\/]+).*', '\\1') }};  # Useless
      {{ slash_redirect }}
      # set     $proxy_url {{dst_scheme}}://{{hash_host_port}}{{dest_path}}$1$is_args$args; # Pb with spec characters
      rewrite {{ src_path }}{{ src_suffix }}(.*) {{dest_path}}$1 break;
      proxy_pass         {{dst_scheme}}://{{hash_host_port}};
      proxy_set_header Connection "";
      proxy_set_header Host {{dest_host}};
      proxy_set_header Client-IP $remote_addr;

      {# AUTO request header for dynatrace monitoring #}
      {% if ("monitoring" not in mapping or mapping["monitoring"] != "false") and ("monitoring" not in nginx_policies or nginx_policies["monitoring"] != "false") and src.startswith('http') %}
      {% set header_val = src | regex_replace('https?:\/\/','') %}
        proxy_set_header x-digitc-dynatrace {{ header_val }};
      {% endif %}
      keepalive_timeout  10000;
      keepalive_requests  50;

      {% if sid_custom_nginx_config and mapping["has as CPL complex code"] is not none %}
        {{ mapping["has as CPL complex code"] }}
      {% endif %}

      #########################
      # MAPPING MODSEC CONFIG #
      #########################
      {#
      {% if modsec_enabled %}
        {% include "nginx-http_server_location-modsec.j2" %}
      {% endif %}
      #}

      ####################
      # MAPPING OPTIONS  #
      ####################
      {% if mapping["bypasses the cache"] is not none and mapping["bypasses the cache"] == "true" %}
            proxy_cache off;
      {% endif %}
      proxy_set_header Accept-Encoding "";

      {% if mapping["has compression disabled"] is not none and mapping["has compression disabled"] == "true" %}
        gzip_proxied off;
      {% endif %}
    {% endif %}
    {% if port == "443" %}
      proxy_set_header X-Forwarded-Proto "https";
    {% else %}
      proxy_set_header X-Forwarded-Proto "http";
    {% endif %}

    {% if mapping["has as timeout"] is not none and mapping["has as timeout"] != 180 %}
      proxy_read_timeout {{ mapping["has as timeout"] }}s;
    {% endif %}
    {% if mapping["has sorry url"] is none %}
      error_page 500 502 503 504 =307 $default_sorry;
    {% else %}
      error_page 500 502 503 504 =307 {{mapping["has sorry url"]}};
    {% endif %}

    ####################
    # MAPPING REWRITES #
    ####################
    {% include "nginx-http_server_location-rewrites.j2" %}

    #####################
    # MAPPING REDIRECTS #
    #####################
    {% include "nginx-http_server_location-redirects.j2" %}
    break;
  {{'}'}}
{% endfor %}
